import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;  // (Date)
/**
 * Clase que representa un cronometro
 * 
 * @author (Programacion Orientada A Objetos - Gonzalez Donat - Neri Andriano) 
 * @version (9/05/12)
 */
public class Cronometro extends Actor
{
    Date cont;      //hace referencia a un objeto de tipo Date para almacenar el tiempo inicial
    Date cont2;     //hace referencia a un objeto de tipo Date para almacenar el tiempo final
    boolean aux;
    /**
     * Constructor para la clase Cronometro
     */
    public Cronometro()
    {
        cont = null;
        boolean aux=false;
        this.setImage(new GreenfootImage(
                          " Tiempo  200 ",
                          30,java.awt.Color.WHITE,
                          java.awt.Color.BLACK));
    }
    /**
     * Metodo que se encarga de mandar llamar a las
     * actualizaciones de los valores de los contadores
     */
    public void act() 
    {
        
        if(cont == null)
            this.inicializa();
        this.actualizaCrono();
    }    
    /**
     * Se encarga de inicializar el contador para tener
     * una referencia de tiempo inicial
     */
    public void inicializa()
    {
        cont = new Date();
    }
    /**
     * Actualiza el cronometro cada segundo
     */
    public void actualizaCrono()
    {
        cont2 = new Date();
        this.setImage(new GreenfootImage(" Tiempo  "+
                           String.valueOf(200-(cont2.getTime() - cont.getTime())/1000)+" "
                          ,30,java.awt.Color.WHITE
                          ,java.awt.Color.BLACK));
        if((200-(cont2.getTime() - cont.getTime())/1000)==0||aux==true)
        {
            aux=false;
            ((Escenario)this.getWorld()).disminuyeVidas();
        }
    }
    
    /**
     * Hace el contador nulo para que vuelva a ser inicializado.
     */
    public void modifCont()
    {
        cont=null;
    }
    
    /**
     * Modifica el Booleano para cuando el mono se queda sin piso.
     */
    public void modifBool()
    {
        aux=true;
    }
}
