import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Clase Goma representa una goma que puede aplastar al mono
 * 
 * @author (Programacion Orientada A Objetos - Gonzalez Donat - Neri Andriano) 
 * @version (9/05/12)
 */
public class Goma extends Obstaculo
{
    private int cont;   //contador para controlar los tiempos activos e inactivos de la goma
    private int lim;    //numero de pixeles que se movera en vertical
    
    /**
     * Constructor para la clase Goma
     * @param m referencia al mono con el que interactuara
     */
    public Goma(Mono m)
    {
        super(m);
        cont = 0;
        lim = 50;
    }
    /**
     * Llama al metodo que hace las acciones de la goma
     */
    public void act() 
    {
        this.borra();
    } 
    /**
     * Se encarga de mover la goma despues de cierto tiempo 
     * en base al contador 
     */
    public void borra()
    {
        if(cont > lim/10*5-5 && cont <=lim/10*5)
            this.setLocation(this.getX(),this.getY()+10);
        if(cont > lim/10*7-5 && cont <= lim/10*7)
            this.setLocation(this.getX(),this.getY()-10);
        cont=cont<lim?cont+1:0;
    }
    /**
     * Si hace contacto con el mono le quita una vida
     */
    public void accion()
    {
        ((Escenario)this.getWorld()).disminuyeVidas();
    }
    
}