import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Clase Gota representa a las gotas que pueden matar al mono y caen desde la tuberia.
 * 
 * @author (Programacion Orientada A Objetos - Gonzalez Donat - Neri Andriano) 
 * @version (15/05/12)
 */
public class Gota extends Obstaculo
{
    int vel; //indicara con que velocidad caera la gota.
    
    /**
     * Constructor para la clase Gota
     * @param m Referencia al mono.
     * @param v Velocidad de la gota al caer.
     */
    public Gota(Mono m,int v)
    {
        super(m);
        vel = v;
    }
    
    /**
     *Hace el movimiento de la Gota y checa si ya esta en posición para ser borrada.
     */
    public void act() 
    {
        this.setLocation(this.getX(),this.getY()+vel);
        this.borrate();
    }   
    
    /**
     * Ejecuta la accion para disminuir la vida del mono.
     */
    public void accion()
    {
        ((Escenario)this.getWorld()).disminuyeVidas();
    }
    
    /**
     * Checa la posicion de la Gota para eliminarla.
     */
    public void borrate()
    {
        if(this.getY()>=this.getWorld().getHeight()-10)
            ((Escenario)this.getWorld()).elimina(this);
    }
}
